#import "PControl.h"
#import "Plot3DView.h"
#import <appkit/appkit.h>
#import <dpsclient/event.h>
#import <dpsclient/psops.h>
#import <appkit/color.h>
#import <stdio.h>
#import <math.h>
#import <ctype.h>
#include <libc.h>
#import "Expression.h"
#import "DensView.h"

int comp(Point *x,Point *y);

@implementation PControl
-init
{
[super init];
return self;
}

/* Called once by the Plot3DView to do initialization and pass pref pointer */
-startup:(SetPref *)Pref
{
	pref=Pref;
/* display initial preferences settings */
	curPref=0;
	bpath=(char *)[[NXBundle mainBundle] directory];
	[symsel selectCellWithTag:pref[0].sym+1];
	[colorSel setColor:NXConvertRGBToColor(pref[curPref].color[0], 
		pref[curPref].color[1],pref[curPref].color[2])];
	[colorSel2 setColor:NXConvertRGBToColor(pref[curPref].lcolor[0], 
		pref[curPref].lcolor[1],pref[curPref].lcolor[2])];
	equation=[equation docView];
	[equation setText:[pref[0].expr text]];
/* make sure plot agrees with displayed min/max values */
	[gridx setIntValue:pref[curPref].nx];
	[gridy setIntValue:pref[curPref].ny];
/*	[d3View zoomTo:[minX floatValue] :[minY floatValue] :[maxX floatValue] :[maxY floatValue]];*/
[self readFile:self];
return self;
}

/* display preferences for a data set */
-disPref:sender
{
curPref=[[sender selectedCell] tag];
[symsel selectCellWithTag:pref[curPref].sym+1];
[colorSel setColor:NXConvertRGBToColor(pref[curPref].color[0], 
	pref[curPref].color[1],pref[curPref].color[2])];
[colorSel2 setColor:NXConvertRGBToColor(pref[curPref].lcolor[0], 
	pref[curPref].lcolor[1],pref[curPref].lcolor[2])];

if (pref[curPref].fileData==NULL) [ffSel selectCellWithTag:0];
else [ffSel selectCellWithTag:1];
[equation setText:[pref[curPref].expr text]];
[gridx setIntValue:pref[curPref].nx];
[gridy setIntValue:pref[curPref].ny];
[d3View zoom:self];
return self;
}

/* put preferences from screen into SetPref for curPref set */
-stoPref:sender
{
char *tmp;
int i,j,k;
pref[curPref].sym=[[symsel selectedCell] tag]-1;
NXConvertColorToRGB([colorSel color], 
	&pref[curPref].color[0],&pref[curPref].color[1],&pref[curPref].color[2]);
NXConvertColorToRGB([colorSel2 color], &pref[curPref].lcolor[0]
	,&pref[curPref].lcolor[1],&pref[curPref].lcolor[2]);
pref[curPref].nx=[gridx intValue];
if (pref[curPref].nx>80||pref[curPref].nx<4) 
	[gridx setIntValue:pref[curPref].nx=10];
pref[curPref].ny=[gridy intValue];
if (pref[curPref].ny>80||pref[curPref].ny<4) 
	[gridy setIntValue:pref[curPref].ny=10];
tmp=malloc([equation textLength]+50);
[equation getSubstring:tmp start:0 length:[equation textLength]+1];
/* Fix equation for parsing */
k=strlen(tmp);
for (i=0; i<k; i++) {
	if (tmp[i]=='[') tmp[i]='(';
	if (tmp[i]==']') tmp[i]=')';
	if (isupper(tmp[i])) tmp[i]=tolower(tmp[i]);
	if ((tmp[i]=='+'||tmp[i]=='-')&&(isdigit(tmp[i+1])||tmp[i+1]=='.')) {
		for (j=k; j>i; j--) tmp[j+1]=tmp[j];
		tmp[i+1]=' ';
		k++;
	}
}

/* if the equation doesn't parse, set it to 0 */
if (strlen(tmp)==0 ||
	 [pref[curPref].expr parse:tmp]==0) {
	[equation setText:"0"];
	[pref[curPref].expr parse:"0"];
	}
[d3View zoom:self];
return self;
}

/* Read 3d data from a file and put it into the current data set */
/* does NOT wait for an "OK" press, like other prefs */
-readFile:sender
{
id panel;
int i,c,cc=0;
char s[120],sc[20];
FILE *in;
float x0,x1,y0,y1,f;
Point *p;

if (pref[curPref].fileData!=NULL) { free(pref[curPref].fileData); pref[curPref].
fileData=NULL; }

if (sender!=self) {
	/* get a filespec from the user */
	panel=[[OpenPanel new] allowMultipleFiles:NO];
	if (![panel runModalForTypes:NULL]) {
		[ffSel selectCellWithTag:0];
		[equation setText:"0"];
		[pref[curPref].expr parse:"0"];
		return self;
	}
	
	/* if we can't open the file, go back to equation mode */
	in=fopen([panel filename],"r");
}
else {
	[ffSel selectCellWithTag:1];
	sprintf(s,"%s/title.3d",bpath);
	in=fopen(s,"r");
}

if (fgets(s,80,in)==NULL) {
	[ffSel selectCellWithTag:0];
	[equation setText:"0"];
	[pref[curPref].expr parse:"0"];
        return self;
}

/* ignore leading # lines */
while (s[0]=='#') { fgets(s,80,in); cc++; }

/* accept either "x,y,z\n" or "x y z\n" files */
strcpy(sc," %f , %f , %f");
if (sscanf(s,sc,&x0,&y0,&f)!=3) {
	strcpy(sc," %f %f %f");
	if (sscanf(s,sc,&x0,&y0,&f)!=3) {
		[ffSel selectCellWithTag:0];
		[equation setText:"0"];
		[pref[curPref].expr parse:"0"];
        	return self;
	}
}

/* count the number of points in the file */
x1=x0; y1=y0;
c=1;
while (fscanf(in,sc,&f,&f,&f)==3) c++;
rewind(in);

/* 2nd pass, allocate memory and read data into array */
p=pref[curPref].fileData=malloc(sizeof(Point)*c);
pref[curPref].nfdata=c;

for (i=0; i<cc; i++) fgets(s,80,in);
for (i=0; i<c; i++) {
	fscanf(in,sc,&p[i].x,&p[i].y,&p[i].z);
	if (p[i].x>x1) x1=p[i].x;
	if (p[i].x<x0) x0=p[i].x;
	if (p[i].y>y1) y1=p[i].y;
	if (p[i].y<y0) y0=p[i].y;
}
qsort(p,cc,sizeof(Point),comp);
if (pref[curPref].data!=NULL) free(pref[curPref].data);
pref[curPref].data=malloc(sizeof(Point)*pref[curPref].nfdata);
/* x0-=fabs(x0)/500.0+fabs(x1)/500.0;
x1+=fabs(x0)/500.0+fabs(x1)/500.0;
y0-=fabs(y0)/500.0+fabs(y1)/500.0;
y1+=fabs(y0)/500.0+fabs(y1)/500.0; */
[minX setFloatValue:x0];
[minY setFloatValue:y0];
[maxX setFloatValue:x1];
[maxY setFloatValue:y1];

/* equation is now used to modify data Z values, set initial formula for */
/* z(x,y,z)=z. ie - for log plots you would enter "log(z)" */
[equation setText:"z"];
[pref[curPref].expr parse:"z"];

/* update the display */
[self setMinMax:self];
[d3View zoom:self];
return self;
}

/* return a data set to equation mode, free memory used by the file */
-clearFile:sender
{
if (pref[curPref].fileData!=NULL) { free(pref[curPref].fileData); pref[curPref].fileData=NULL; }
pref[curPref].nfdata=0;

[equation setText:"0"];
[pref[curPref].expr parse:"0"];
[d3View zoom:self];
return(self);
}

/* minz and maxz can be modified before returning, but currently aren't */
-minmaxZ:(float *)minz :(float *)maxz
{
[dminZ setFloatValue:*minz];
[dmaxZ setFloatValue:*maxz];
if ([dzSwitch intValue]) {
	[minZ setFloatValue:*minz];
	[maxZ setFloatValue:*maxz];
}
*minz=[minZ floatValue];
*maxz=[maxZ floatValue];
return self;
}

/* display new min/max values (does not inform the views of the change) */
-setMM:(float)minx :(float)maxx :(float)miny :(float)maxy
{
[minX setFloatValue:minx];
[minY setFloatValue:miny];
[maxX setFloatValue:maxx];
[maxY setFloatValue:maxy];
return self;
}

/* Tell the Plot3DView and (indirectly) the DensView about new max/min vals */
-setMinMax:sender
{
[d3View zoomTo:[minX floatValue] :[minY floatValue] :[maxX floatValue] :[maxY floatValue]];
[d3View zoom:self];
return self;
}

/* zoom in by a fixed amount */
-zoomIn:sender
{
float x,y,x1,y1;
x1=[maxX floatValue];
x=[minX floatValue];
y1=[maxY floatValue];
y=[minY floatValue];

[maxX setFloatValue:x1-(x1-x)/4.0];
[minX setFloatValue:x+(x1-x)/4.0];
[maxY setFloatValue:y1-(y1-y)/4.0];
[minY setFloatValue:y+(y1-y)/4.0];

[self setMinMax:self];
[d3View zoom:self];
return self;
}

/* zoom out by a fixed amount */
-zoomOut:sender
{
float x,y,x1,y1;
x1=[maxX floatValue];
x=[minX floatValue];
y1=[maxY floatValue];
y=[minY floatValue];

[maxX setFloatValue:x1+(x1-x)/4.0];
[minX setFloatValue:x-(x1-x)/4.0];
[maxY setFloatValue:y1+(y1-y)/4.0];
[minY setFloatValue:y-(y1-y)/4.0];

[self setMinMax:self];
[d3View zoom:self];
return self;
}

/* sent by DensView, min/max are from 0.0 to 1.0, not real units */
-zoomTo:(float)minx :(float)miny :(float)maxx :(float)maxy
{
float x0,x1,y0,y1;

x0=[minX floatValue];
x1=[maxX floatValue];
y0=[minY floatValue];
y1=[maxY floatValue];

[minX setFloatValue:x0+(x1-x0)*minx];
[minY setFloatValue:y0+(y1-y0)*miny];
[maxX setFloatValue:x0+(x1-x0)*maxx];
[maxY setFloatValue:y0+(y1-y0)*maxy];
[self setMinMax:self];
[d3View zoom:self];
return self;
}

/* update the density plot */
-updDen
{
static float *densData=NULL;
static int ndd=0;
int k,i,nx,ny;
NXRect rec;
float a;

nx=pref[curPref].nx; 
ny=pref[curPref].ny;
if (ndd<(nx*ny)) {
	if (densData!=NULL) free(densData);
	densData=malloc(nx*ny*sizeof(float));
	ndd=nx*ny;
}

if (pref[curPref].fileData==NULL||nx*ny==pref[curPref].ndata) {
	for (k=0; k<pref[curPref].ndata; k++) densData[k]=pref[curPref].data[k].z;
}
else {
	for (k=0; k<(nx*ny); k++) densData[k]= -.5;
	for (k=0; k<pref[curPref].ndata; k++) {
		i=floor((pref[curPref].data[k].x+.5)*(float)nx)+floor((pref[curPref].data[k].y+.5)*(float)ny)*nx;
		if (i>=0 && i<ndd) densData[i]=pref[curPref].data[k].z;
	}
}
if (pref[curPref].ndata>0) {
	a=(pref[curPref].data[pref[curPref].ndata-1].x-pref[curPref].data[0].x)/2.0;
	rec.origin.x=pref[curPref].data[0].x/2.0+.5-(1.0/(float)nx)/2.0;
	rec.size.width=a*(float)nx/(float)(nx-1);

	a=(pref[curPref].data[pref[curPref].ndata-1].y-pref[curPref].data[0].y)/2.0;
	rec.origin.y=pref[curPref].data[0].y/2.0+.5-(1.0/(float)ny)/2.0;
	rec.size.height=a*(float)ny/(float)(ny-1);
}
else { rec.origin.y=rec.origin.x=0.0; rec.size.height=rec.size.width=1.0; }
if (pref[curPref].sym!= -1) [dView setData:nx :ny :densData :-1.0 :1.0 :rec];
else [dView setData:0 :0 :NULL :-1.0 :1.0 :rec];
return self;
}

int comp(Point *x,Point *y)
{
if (x->y<y->y) return(-1);
if (x->y>y->y) return(1);
if (x->x<y->x) return(-1);
if (x->x>y->x) return (1);
return (0);
}

-saveData:sender
{
id pan;
FILE *out;
int i;
float x0,x1,y0,y1,z0,z1;
x0=[minX floatValue];
x1=[maxX floatValue]-x0;
y0=[minY floatValue];
y1=[maxY floatValue]-y0;
z0=[minZ floatValue];
z1=[maxZ floatValue]-z0;

pan=[SavePanel new];
if ([pan runModal]) {
	out=fopen([pan filename],"w");
	fprintf(out,"# Created by Plot3D\n");
	for (i=0; i<pref[curPref].ndata; i++) 
		fprintf(out,"%f\t%f\t%f\n",(pref[curPref].data[i].x/2.0+.5)*x1+x0,
			(pref[curPref].data[i].y/2.0+.5)*y1+y0,
			(pref[curPref].data[i].z/2.0+.5)*z1+z0);
	fclose(out);
}
return self;
}

@end
