#import "Plot3DView.h"
#import "PlotShape.h"
#import <ri/ri.h>
#import <math.h>

#define SC .05
#define SCP1 SC/1.732
#define SCP2 SC/.866
#define SCP3 SC/2.45
#define SCP4 SC/1.633-SCP3

@implementation PlotShape:N3DShape
- renderSelf:(RtToken)context
{
int i,j;
float x,y,z;
static RtPoint square[4]= {{-1.0,-1.0,-1.01},{1.0,-1.0,-1.01},{1.0,1.0,-1.01},{-1.0,1.0,-1.01}};
static RtPoint bsquare[4]= {{-100.0,-100.0,-40.0},{100.0,-100.0,-40.0},{100.0,100.0,-40.0},{-100.0,100.0,-40.0}};
static RtPoint Box[8] = {{-SC,-SC,-SC},{-SC,-SC,SC},{-SC,SC,SC},{-SC,SC,-SC}, {SC,-SC,-SC},{SC,-SC,SC},{SC,SC,SC},{SC,SC,-SC}};
static RtInt BoxP[24] = {0,1,2,3,0,1,5,4,4,5,6,7,2,3,7,6,1,5,6,2,0,3,7,4};
static RtInt BoxV[6]={4,4,4,4,4,4};
static RtPoint Pyr[4] = {{0,-SCP2,-SCP4},{-SC,SCP1,-SCP4},{SC,SCP1,-SCP4}, {0,0,SCP4}};
static RtInt PyrP[12] = {0,1,2,0,1,3,0,2,3,1,2,3};
static RtInt PyrV[4] = {3,3,3,3};
static RtPoint axes1[2] = {{-1,-1,-1},{1,-1,-1}};
static RtPoint axes2[2] = {{-1,-1,-1},{-1,1,-1}};
static RtPoint axes3[2] = {{-1,-1,-1},{-1,-1,1}};
static RtColor bgCol = {1.0,1.0,1.0};
static RtColor bCol = { 0,0,0 };
static RtColor dCol = { 1.0,1.0,1.0 };

RiSurface("constant",RI_NULL);
if (mode>=4) {
	RiColor(bgCol);
	RiPolygon(4,RI_P,(RtPointer)bsquare,RI_NULL);
}
RiRotate(theta-90.0,1.0,0,0);
RiRotate(-chi,0,0,1.0);
RiColor(bCol);
if (flags&1) RiPolygon(4,RI_P,(RtPointer)square,RI_NULL);
RiSurface("matte",RI_NULL);
RiColor(dCol);
if (flags&2 && (mode&3)>1) {
	RiTransformBegin();
	RiTranslate(-1.0,-1.0,-1.0);
	RiCylinder(.015,0.0,2.0,360.0,RI_NULL);
	RiTransformEnd();
	RiTransformBegin();
	RiRotate(-90.0,0,1.0,0.0);
	RiTranslate(-1.0,-1.0,-1.0);
	RiCylinder(.015,0.0,2.0,360.0,RI_NULL);
	RiTransformEnd();
	RiTransformBegin();
	RiRotate(90.0,1.0,0.0,0.0);
	RiTranslate(-1.0,-1.0,-1.0);
	RiCylinder(.015,0.0,2.0,360.0,RI_NULL);
	RiTransformEnd();
}
else if (flags&2) {
	RiColor(bCol);
	RiLine(2,RI_P,axes1,RI_NULL);
	RiLine(2,RI_P,axes2,RI_NULL);
	RiLine(2,RI_P,axes3,RI_NULL);
}

if (data==NULL) return self;
for (i=0; i<MAXSETS; i++) {
	if (data[i].sym<0) continue;
	if ((mode&3)>=2) RiColor(data[i].color);
	else RiColor(data[i].lcolor);
	switch(data[i].sym) {
	case 0:
		for (j=0; j<data[i].ndata; j++) {
			x=data[i].data[j].x;
			y=data[i].data[j].y;
			z=data[i].data[j].z;
			RiTransformBegin();
			RiTranslate(x,y,z);
			RiPointsPolygons(6,BoxV,BoxP,RI_P,(RtPointer)Box,RI_NULL);
			RiTransformEnd();			 
  		}
		break;
	case 1:
		for (j=0; j<data[i].ndata; j++) {
			x=data[i].data[j].x;
			y=data[i].data[j].y;
			z=data[i].data[j].z;
			RiTransformBegin();
			RiTranslate(x,y,z);
			RiPointsPolygons(4,PyrV,PyrP,RI_P,(RtPointer)Pyr,RI_NULL);
			RiTransformEnd();			 
  		}
		break;
	case 2:
		for (j=0; j<data[i].ndata; j++) {
			x=data[i].data[j].x;
			y=data[i].data[j].y;
			z=data[i].data[j].z;
			RiTransformBegin();
			RiTranslate(x,y,z);
			RiSphere(SC,-SC,SC,360.0,RI_NULL);
			RiTransformEnd();			 
  		}
		break;
	case 3:
		for (j=0; j<data[i].ndata; j++) {
			x=data[i].data[j].x;
			y=data[i].data[j].y;
			z=data[i].data[j].z;
			RiTransformBegin();
			RiTranslate(x,y,z);
			RiTorus(SC,SC/3.0,0,360.0,360.0,RI_NULL);
			RiTransformEnd();			 
  		}
		break;
	case 4:
		for (j=0; j<data[i].ndata; j++) {
			x=data[i].data[j].x;
			y=data[i].data[j].y;
			z=data[i].data[j].z;
			RiTransformBegin();
			RiTranslate(x,y,z);
			RiCylinder(SC,-SC,SC,360.0,RI_NULL);
			RiTransformEnd();			 
  		}
		break;
		
	case 5:
	case 6:
		/* if (data[i].fileData!=NULL) break;	/* no mesh in file mode */
		if (data[i].nx*data[i].ny!=data[i].ndata) break;
		RiPatchMesh(RI_BILINEAR,data[i].nx,RI_NONPERIODIC,data[i].ny,
			RI_NONPERIODIC,RI_P,(RtPointer)data[i].data,RI_NULL);
		break;
	}
}
return self;
}

-setData:(SetPref *)Data :(int)Mode :(int)Flags
{
int i,j;

data=Data;
mode=Mode;
flags=Flags;
/*
mmx[0]=mmy[0]=mmz[0]=MAXFLOAT;
mmx[1]=mmy[1]=mmz[1]=-MAXFLOAT;

for (i=0; i<MAXSETS; i++) {
	for (j=0; j<data[i].ndata; j++) {
		if (data[i].data[j].x<mmx[0]) mmx[0]=data[i].data[j].x;
		if (data[i].data[j].x>mmx[1]) mmx[1]=data[i].data[j].x;
		if (data[i].data[j].y<mmy[0]) mmy[0]=data[i].data[j].y;
		if (data[i].data[j].y>mmy[1]) mmy[1]=data[i].data[j].y;
		if (data[i].data[j].z<mmz[0]) mmz[0]=data[i].data[j].z;
		if (data[i].data[j].z>mmz[1]) mmz[1]=data[i].data[j].z;
	}
}
mmx[1]=(mmx[1]-mmx[0])/2.0;
mmy[1]=(mmy[1]-mmy[0])/2.0;
mmz[1]=(mmz[1]-mmz[0])/2.0;
*/
return self;
}

-setAng:(float)Theta :(float)Chi
{
theta=Theta*57.3;
chi=Chi*57.3;
return self;
}

- setSurfaceType:(N3DSurfaceType)st andDescendants:(BOOL)flag
{
[super setSurfaceType:st andDescendants:flag];
return self;
}

@end
  
